#!/usr/bin/perl
use File::Spec::Functions;

while(<>) {
	$in="";
	$abs="$_";
	$i = 0;
	while ( $in ne $abs) {
		$in = $abs;
		chomp $in;
		$l=qx{stat --format="%N" $in};
		chomp $l;
		$type=qx{stat --format="%F" $in};
		chomp $type;
		if ($type ne 'symbolic link') {
			print "$in\n";
			last;
		}
		($s,$t) = (split(m{(?<!\\)[\s]+},$l))[0,2];
		for $n (\$s,\$t) { $$n =~ s{(^`|\'$)}{}g };
		$d=qx{dirname "$s"};
		chomp $d;
		$abs = File::Spec->rel2abs($t,$d);
		$i++;
		if ($i > 10) {
			print "Cyclic link (or too deply nested)\n";
			last;
		}
	}
}
